﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace ActiveReports7_JpegExport_Csharp
{
    public partial class ViewerForm : Form
    {
        GrapeCity.ActiveReports.SectionReport rpt = new GrapeCity.ActiveReports.SectionReport();

        private void ExportJpeg(GrapeCity.ActiveReports.Document.SectionDocument ReportDocument, string folderSavePath)
        {
            int pageindex = 0;

           
            foreach (GrapeCity.ActiveReports.Document.Section.Page _pg  in ReportDocument.Pages)
            {

                _pg.Units = GrapeCity.ActiveReports.Document.Section.Units.Pixels;
                Bitmap bmp = new Bitmap((int)_pg.Width, (int)_pg.Height);
                Graphics g = Graphics.FromImage(bmp);
                g.FillRectangle(new SolidBrush(Color.White), 0, 0, bmp.Width, bmp.Height);
                _pg.Draw(g, new RectangleF(0, 0, _pg.Width, _pg.Height));
                bmp.Save(folderSavePath +"\\" +"Page" + (pageindex + 1).ToString() + ".jpg", System.Drawing.Imaging.ImageFormat.Jpeg);
                pageindex++;
            } 
        }

        string GetPath(string filename)
        {
            string path = Application.StartupPath;
            int pos = path.IndexOf(@"\bin");
            path = path.Substring(0, pos) +"\\"+filename;

            return path;
        }

        public ViewerForm()
        {
            InitializeComponent();

              ToolStripButton btnJpegExport=new ToolStripButton();
              btnJpegExport.Text="JPEG Export";
              btnJpegExport.Click += (s, e) =>
              {
                  FolderBrowserDialog dlg = new FolderBrowserDialog();
                  dlg.ShowDialog();

                  if (dlg.SelectedPath != "")
                  {
                      ExportJpeg(viewer1.Document, dlg.SelectedPath);
                  }


              };
            
              viewer1.Toolbar.MainBar.Items.Insert(viewer1.Toolbar.MainBar.Items.Count, btnJpegExport);
        }

        private void ViewerForm_Load(object sender, EventArgs e)
        {


            GrapeCity.ActiveReports.SectionReport rpt = new GrapeCity.ActiveReports.SectionReport();
            System.Xml.XmlTextReader xtr = new System.Xml.XmlTextReader(GetPath("Annotation.rpx"));
            rpt.LoadLayout(xtr);
            GrapeCity.ActiveReports.Data.OleDBDataSource ds = new GrapeCity.ActiveReports.Data.OleDBDataSource();
            ds.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + GetPath("NWIND.MDB") + ";Persist Security Info=False";
            ds.SQL = "SELECT * FROM Invoices ORDER BY Customers.CompanyName, OrderID";
            rpt.DataSource = ds;
            rpt.Run();
            viewer1.Document = rpt.Document;
            xtr.Close();
        }
    }
}
